// Fill out your copyright notice in the Description page of Project Settings.


#include "Enemy/DistantEnemy/Projectile/LMProjectile.h"

// #include "VectorTypes.h"
#include "Components/SphereComponent.h"
#include "GameFramework/ProjectileMovementComponent.h"
// #include "Player/LMHealthComponent.h"
// #include "Player/LMHitBox.h"
// #include "Player/LMPlayer.h"

// Sets default values
ALMProjectile::ALMProjectile()
{
	PrimaryActorTick.bCanEverTick = true;
	PrimaryActorTick.bCanEverTick = true;
	ProjectileCollision = CreateDefaultSubobject<USphereComponent>(TEXT("ProjectileCollision"));
	SetRootComponent(ProjectileCollision);
	// // Collisions :
	ProjectileCollision->SetCollisionEnabled(ECollisionEnabled::NoCollision);
	ProjectileCollision->SetCollisionResponseToAllChannels(ECollisionResponse::ECR_Overlap);
	// ProjectileCollision->OnComponentBeginOverlap.AddDynamic(this, &ALMProjectile::OnSphereOverlap);
	
	ProjectileMesh = CreateDefaultSubobject<UStaticMeshComponent>(TEXT("ProjectileMesh"));
	ProjectileMesh->SetupAttachment(ProjectileCollision);

	ProjectileMovement = CreateDefaultSubobject<UProjectileMovementComponent>(TEXT("ProjectileMovement"));
}

// Called when the game starts or when spawned
void ALMProjectile::BeginPlay()
{
	Super::BeginPlay();
	InitialLocation = GetActorLocation();
	
}
// TO DEBUG OR ERASE
// void ALMProjectile::OnSphereOverlap(UPrimitiveComponent* OverlappedComponent, AActor* OtherActor,
// 	UPrimitiveComponent* OtherComp, int32 OtherBodyIndex, bool bFromSweep, const FHitResult& SweepResult)
// {
// 	if(GEngine)
// 	{
// 		GEngine->AddOnScreenDebugMessage(-1, 2.f, FColor::Yellow, "1Damage");
// 	}
// 	if(ALMPlayer* Player = Cast<ALMPlayer>(OtherActor))
// 	{
// 		if(GEngine)
// 		{
// 			GEngine->AddOnScreenDebugMessage(-1, 2.f, FColor::Yellow, "2Damage");
// 		}
// 		if (ULMHitBox* HitBox = Cast<ULMHitBox>(OtherComp))
// 		{
// 			Player->GetHealthComponent()->TakeDamage(AttackingDamage);
// 			if(GEngine)
// 			{
// 				GEngine->AddOnScreenDebugMessage(-1, 2.f, FColor::Yellow, "3Damage");
// 			}
// 		}
// 	}
// 	Destroy();
// }

// Called every frame
void ALMProjectile::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);
	if(FVector::Distance(GetActorLocation(), InitialLocation) > MaxRange)
	{
		Destroy();
	}
	

}

